<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no, minimal-ui"><title>JavaScript: Datové struktury</title><meta name="author" content="Ing. Jan Kolomazník, Ph.D. &lt;jan.kolomaznik@gmail.com&gt;"><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/css/reset.css"><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/css/reveal.css"><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/css/theme/serif.css" id="theme"><!--This CSS is generated by the Asciidoctor reveal.js converter to further integrate AsciiDoc's existing semantic with reveal.js--><style type="text/css">.reveal div.right{float:right}

/* listing block */
.reveal .listingblock.stretch>.content{height: 100%}
.reveal .listingblock.stretch>.content>pre{height: 100%}
.reveal .listingblock.stretch>.content>pre>code{height:100%;max-height:100%}

/* tables */
table{border-collapse:collapse;border-spacing:0}
table{margin-bottom:1.25em;border:solid 1px #dedede}
table thead tr th,table thead tr td,table tfoot tr th,table tfoot tr td{padding:.5em .625em .625em;font-size:inherit;text-align:left}
table tr th,table tr td{padding:.5625em .625em;font-size:inherit}
table thead tr th,table tfoot tr th,table tbody tr td,table tr td,table tfoot tr td{display:table-cell;line-height:1.6}
td.tableblock>.content{margin-bottom:1.25em}
td.tableblock>.content>:last-child{margin-bottom:-1.25em}
table.tableblock,th.tableblock,td.tableblock{border:0 solid #dedede}
table.grid-all>thead>tr>.tableblock,table.grid-all>tbody>tr>.tableblock{border-width:0 1px 1px 0}
table.grid-all>tfoot>tr>.tableblock{border-width:1px 1px 0 0}
table.grid-cols>*>tr>.tableblock{border-width:0 1px 0 0}
table.grid-rows>thead>tr>.tableblock,table.grid-rows>tbody>tr>.tableblock{border-width:0 0 1px}
table.grid-rows>tfoot>tr>.tableblock{border-width:1px 0 0}
table.grid-all>*>tr>.tableblock:last-child,table.grid-cols>*>tr>.tableblock:last-child{border-right-width:0}
table.grid-all>tbody>tr:last-child>.tableblock,table.grid-all>thead:last-child>tr>.tableblock,table.grid-rows>tbody>tr:last-child>.tableblock,table.grid-rows>thead:last-child>tr>.tableblock{border-bottom-width:0}
table.frame-all{border-width:1px}
table.frame-sides{border-width:0 1px}
table.frame-topbot,table.frame-ends{border-width:1px 0}
.reveal table th.halign-left,.reveal table td.halign-left{text-align:left}
.reveal table th.halign-right,.reveal table td.halign-right{text-align:right}
.reveal table th.halign-center,.reveal table td.halign-center{text-align:center}
.reveal table th.valign-top,.reveal table td.valign-top{vertical-align:top}
.reveal table th.valign-bottom,.reveal table td.valign-bottom{vertical-align:bottom}
.reveal table th.valign-middle,.reveal table td.valign-middle{vertical-align:middle}
table thead th,table tfoot th{font-weight:bold}
tbody tr th{display:table-cell;line-height:1.6}
tbody tr th,tbody tr th p,tfoot tr th,tfoot tr th p{font-weight:bold}
thead{display:table-header-group}

.reveal table.grid-none th,.reveal table.grid-none td{border-bottom:0!important}

/* kbd macro */
kbd{font-family:"Droid Sans Mono","DejaVu Sans Mono",monospace;display:inline-block;color:rgba(0,0,0,.8);font-size:.65em;line-height:1.45;background:#f7f7f7;border:1px solid #ccc;-webkit-border-radius:3px;border-radius:3px;-webkit-box-shadow:0 1px 0 rgba(0,0,0,.2),0 0 0 .1em white inset;box-shadow:0 1px 0 rgba(0,0,0,.2),0 0 0 .1em #fff inset;margin:0 .15em;padding:.2em .5em;vertical-align:middle;position:relative;top:-.1em;white-space:nowrap}
.keyseq kbd:first-child{margin-left:0}
.keyseq kbd:last-child{margin-right:0}

/* callouts */
.conum[data-value] {display:inline-block;color:#fff!important;background:rgba(0,0,0,.8);-webkit-border-radius:50%;border-radius:50%;text-align:center;font-size:.75em;width:1.67em;height:1.67em;line-height:1.67em;font-family:"Open Sans","DejaVu Sans",sans-serif;font-style:normal;font-weight:bold}
.conum[data-value] *{color:#fff!important}
.conum[data-value]+b{display:none}
.conum[data-value]:after{content:attr(data-value)}
pre .conum[data-value]{position:relative;top:-.125em}
b.conum *{color:inherit!important}
.conum:not([data-value]):empty{display:none}
/* Callout list */
.hdlist>table,.colist>table{border:0;background:none}
.hdlist>table>tbody>tr,.colist>table>tbody>tr{background:none}
td.hdlist1,td.hdlist2{vertical-align:top;padding:0 .625em}
td.hdlist1{font-weight:bold;padding-bottom:1.25em}
/* Disabled from Asciidoctor CSS because it caused callout list to go under the
 * source listing when .stretch is applied (see #335)
 * .literalblock+.colist,.listingblock+.colist{margin-top:-.5em} */
.colist td:not([class]):first-child{padding:.4em .75em 0;line-height:1;vertical-align:top}
.colist td:not([class]):first-child img{max-width:none}
.colist td:not([class]):last-child{padding:.25em 0}

/* Override Asciidoctor CSS that causes issues with reveal.js features */
.reveal .hljs table{border: 0}
/* Callout list rows would have a bottom border with some reveal.js themes (see #335) */
.reveal .colist>table th, .reveal .colist>table td {border-bottom:0}
/* Fixes line height with Highlight.js source listing when linenums enabled (see #331) */
.reveal .hljs table thead tr th, .reveal .hljs table tfoot tr th, .reveal .hljs table tbody tr td, .reveal .hljs table tr td, .reveal .hljs table tfoot tr td{line-height:inherit}

/* Columns layout */
.columns .slide-content {
  display: flex;
}

.columns.wrap .slide-content {
  flex-wrap: wrap;
}

.columns.is-vcentered .slide-content {
  align-items: center;
}

.columns .slide-content > .column {
  display: block;
  flex-basis: 0;
  flex-grow: 1;
  flex-shrink: 1;
  padding: .75rem;
}

.columns .slide-content > .column.is-full {
  flex: none;
  width: 100%;
}

.columns .slide-content > .column.is-four-fifths {
  flex: none;
  width: 80%;
}

.columns .slide-content > .column.is-three-quarters {
  flex: none;
  width: 75%;
}

.columns .slide-content > .column.is-two-thirds {
  flex: none;
  width: 66.6666%;
}

.columns .slide-content > .column.is-three-fifths {
  flex: none;
  width: 60%;
}

.columns .slide-content > .column.is-half {
  flex: none;
  width: 50%;
}

.columns .slide-content > .column.is-two-fifths {
  flex: none;
  width: 40%;
}

.columns .slide-content > .column.is-one-third {
  flex: none;
  width: 33.3333%;
}

.columns .slide-content > .column.is-one-quarter {
  flex: none;
  width: 25%;
}

.columns .slide-content > .column.is-one-fifth {
  flex: none;
  width: 20%;
}
</style><link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.12.0-1/css/all.min.css"><link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.12.0-1/css/v4-shims.min.css"><!--Printing and PDF exports--><script>var link = document.createElement( 'link' );
link.rel = 'stylesheet';
link.type = 'text/css';
link.href = window.location.search.match( /print-pdf/gi ) ? "https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/css/print/pdf.css" : "https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/css/print/paper.css";
document.getElementsByTagName( 'head' )[0].appendChild( link );</script></head><body><div class="reveal"><div class="slides"><section class="title" data-state="title"><h1>JavaScript</h1><h2>Datové struktury</h2><div class="preamble"><div class="paragraph"><p><a href="https://eloquentjavascript.net/04_data.html" class="bare">https://eloquentjavascript.net/04_data.html</a></p></div></div><p class="author"><small>Ing. Jan Kolomazník, Ph.D. &lt;jan.kolomaznik@gmail.com&gt;</small></p></section>
<section><section id="_nové_struktury"><h2>Nové struktury</h2><div class="slide-content"><div class="paragraph"><p>Doposud jsme pracovali s jednoduchými proměnnými jako jsou čísla, pravda/nepravda.
V reálně ale většina informací není takto jednoduchá, ale skládá se z více částí.</p></div><div class="ulist"><ul><li><p>Pole nám umožňují ukládat více informací stejného typu</p></li><li><p>Objekty pak umonájí seskupovat informace které patří k sobě, včetně dalších objektů.</p></li></ul></div></div></section><section id="_seznamy"><h2>Seznamy</h2><div class="slide-content"><div class="paragraph"><p>Javascript umožňuje do jedné proměnné uložit více hodnot, například čísla <code>2 3 5 7 11</code>.</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let listOfNumbers = [2, 3, 5, 7, 11];
console.log(listOfNumbers[2]);
// → 5
console.log(listOfNumbers[0]);
// → 2
console.log(listOfNumbers[2 - 1]);
// → 3</code></pre></div></div></div></section><section><div class="slide-content"><h3>Procházení seznamů</h3><div class="paragraph"><p>Seznamy často potřebuje pojit prvek po prvku.</p></div>
<div class="ulist"><ul><li><p>Můžeme použít již známí for cyklus</p></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">for (let i = 0; i &lt; listOfNumbers.length; i++) {
 console.log(`${i}: ${listOfNumbers[i]}`);
}</code></pre></div></div></div></section><section><div class="slide-content"><div class="ulist"><ul><li><p>Nebo použít speciální <em>for-each</em> cyklus</p></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">for (let num of listOfNumbers) {
 console.log(`${num}`);
}</code></pre></div></div></div></section><section id="_vlastnosti"><h2>Vlastnosti</h2><div class="slide-content"><div class="paragraph"><p>Proměnné (závisí na jejich typu) můžou mít kromě hodnoty i vlastnosti (a větší jich skutečně má)</p></div>
<div class="ulist"><ul><li><p>Javascriptu můžeme přistoupit k vlastnosti dvěma způsoby</p><div class="olist arabic"><ol class="arabic"><li><p>Pomocí tečky: <code>"ABC".length</code></p></li><li><p>Pomocí hranatých závorek <code>"ABC"['length']</code>.</p></li></ol></div></li><li><p>Hranaté závorky musíme použít jméno vlastnosti je</p><div class="olist arabic"><ol class="arabic"><li><p>číslo <code>listOfNumbers[2]</code></p></li><li><p>obsahuje <em>nepovolené</em> znaky <code>zamestnanec['John Smith']</code></p></li></ol></div></li></ul></div></div></section><section id="_metody"><h2>Metody</h2><div class="slide-content"><div class="paragraph"><p>Vlastnosti mohou být typu <em>function</em>, v takovém případě je nazýváme metody</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let doh = "Doh";
console.log(typeof doh.toUpperCase);
// → function
console.log(doh.toUpperCase());
// → DOH</code></pre></div></div></div></section><section><div class="slide-content"><div class="paragraph"><p>Metody mají možnost pracovat s hodnotou <em>objektu</em> (proměnné) na které jsou volány a mohou měnit jeho stav</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let sequence = [1, 2, 3];
sequence.push(4);
sequence.push(5);
console.log(sequence);
// → [1, 2, 3, 4, 5]
console.log(sequence.pop());
// → 5
console.log(sequence);
// → [1, 2, 3, 4]</code></pre></div></div></div></section><section id="_objekty"><h2>Objekty</h2><div class="slide-content"><div class="paragraph"><p>Objekt je struktura, která seskupuje vlastnosti a metody.</p></div>
<div class="ulist"><ul><li><p>Javascript od začátku přistupuje k objektům odlišným způsobem než jiné programovací jazyky.</p></li><li><p>Stejně nako u funkcí má několik způsobu jak objekt vytvořit a definovat.</p></li><li><p>Nejjednodušší způsob je použít <code>{</code>, <code>}</code> závorky.</p></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let descriptions = {
 work: "Went to work",
 "touched tree": "Touched a tree"
};</code></pre></div></div></div></section><section><div class="slide-content"><div class="paragraph"><p>Javascript umožňuje pokusit se přistoupit k vlastnosti, která neexistuje, stejne jako je vytvářet nebo odstraňovat</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let anObject = {left: 1, right: 2};
console.log(anObject.left);
// → 1
delete anObject.left;
console.log(anObject.left);
// → undefined
console.log("left" in anObject);
// → false
console.log("right" in anObject);
// → true</code></pre></div></div></div></section><section><div class="slide-content"><div class="paragraph"><p>Díky této volnosti práce s objekty, je někdy vhodné zjistit, jaké všechny vlastnosti a metody objekt obsahuje</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">console.log(Object.keys({x: 0, y: 0, z: 2}));
// → ["x", "y", "z"]</code></pre></div></div></div></section><section><div class="slide-content"><div class="paragraph"><p>Javascript poskytuje funkci <code>Object.assign</code> která kopíruje všechny vlastnosti z jednoho objektu do druhého</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let objectA = {a: 1, b: 2};
Object.assign(objectA, {b: 3, c: 4});
console.log(objectA);
// → {a: 1, b: 3, c: 4}</code></pre></div></div></div></section><section><div class="slide-content"><div class="paragraph"><p>Co je tedy vlastně seznam <code>[]</code>?</p></div></div></section><section><div class="slide-content"><h3>Mutability</h3><div class="paragraph"><p>Jedná se o užitečný koncept, kterému je třeba rozumět.</p></div>
<div class="ulist"><ul><li><p>Objekty se dají dají rozdělit do dvou skupin</p><div class="olist arabic"><ol class="arabic"><li><p>První skupině je možné měnit stav, tedu přiřadit novou hodnotu do vlastnosti a to ať již přímo nebo volánim metody</p></li><li><p><em>immutable</em> objektům toto není, jednou se vytvoří a již tak zůstanou.</p></li></ol></div></li><li><p>Immutable objekty jsou výhodnější z mnoha důvodů</p><div class="ulist"><ul><li><p>String, Numbers, Booleans jsou všechno <em>immutable</em> objekty.</p></li></ul></div></li></ul></div></div></section><section><div class="slide-content"><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">const score = {visitors: 0, home: 0};
// This is okay
score.visitors = 1;
// This isn't allowed
score = {visitors: 1, home: 1};</code></pre></div></div></div></section><section><div class="slide-content"><h3>Porovnání</h3><div class="paragraph"><p>Dalším momentem je porovnání objektů, které se provádí podle místa v paměti, kam proměnná ukazuje, ne podle hodnot vlastností.</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let object1 = {value: 10};
let object2 = object1;
let object3 = {value: 10};

console.log(object1 == object2);
// → true
console.log(object1 == object3);
// → false

object1.value = 15;
console.log(object2.value);
// → 15
console.log(object3.value);
// → 10</code></pre></div></div></div></section></section>
<section><section id="_příklad"><h2>Příklad</h2><div class="slide-content"><div class="paragraph"><p>Pro ukotvení konceptů udělejme si následující příklad</p></div><div class="quoteblock"><div class="title">Veverkodlak</div><blockquote><div class="paragraph"><p>Jacques se čas od času v noci mění na veverku a to mu dělá docela starosti.
Rozhodl se tedy vést si deník a zjistit na základě čeho se mění.
Zaznamenává si události, které se ten den udály a jestli se proměnil</p></div></blockquote></div></div></section><section><div class="slide-content"><div class="paragraph"><p>Něco jako &#8230;&#8203;</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let journal = [
 {events: ["work", "touched tree", "pizza",
           "running", "television"],
  squirrel: false},
 {events: ["work", "ice cream", "cauliflower",
           "lasagna", "touched tree", "brushed teeth"],
  squirrel: false},
 {events: ["weekend", "cycling", "break", "peanuts",
           "beer"],
  squirrel: true},
 /* and so on... */
];</code></pre></div></div></div></section><section id="_vedení_záznamu"><h2>Vedení záznamu</h2><div class="slide-content"><div class="paragraph"><p>Vytvoříme metodu, která umožní přidávat události do deníku.</p></div>
<div class="ulist"><ul><li><p>Přidání položky do seznamu se provádí metodou <code>.push(polozka)</code></p></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">addEntry(["work", "touched tree", "pizza", "running",
         "television"], false);
addEntry(["work", "ice cream", "cauliflower", "lasagna",
         "touched tree", "brushed teeth"], false);
addEntry(["weekend", "cycling", "break", "peanuts",
         "beer"], true);</code></pre></div></div></div></section><section><div class="slide-content"><div class="paragraph"><p>Možné řešení</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let journal = [];

function addEntry(events, squirrel) {
 journal.push({events, squirrel});
}</code></pre></div></div></div></section><section id="_výpočet_korelace"><h2>Výpočet korelace</h2><div class="slide-content"><div class="paragraph"><p>Korelace uvádí míru jak jsou dva jevy na sobě závislé dodávanou číslem v intervalu od <em>-1 do 1</em></p></div>
<div class="ulist"><ul><li><p>Hodnota <strong>1</strong> znamená že jsou na sobě závislé (když jeden tak i druhý)</p></li><li><p>Hodnota <strong>-1</strong> že se defakto vylučuji (když jeden tak druhý ne)</p></li><li><p>Vzoreček:</p></li></ul></div>
<div class="imageblock" style=""><img src="media/phi_formula.png" alt="phi formula"></div></div></section><section><div class="slide-content"><div class="imageblock" style=""><img src="media/pizza-squirrel.svg" alt="pizza squirrel"></div></div></section><section><div class="slide-content"><div class="paragraph"><p>Vytvořme funkci, která dostane tabulku (pole obsahující 4 číselné hodnoty) a vypočítá hodnotu <strong>ϕ</strong></p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">console.log(phi([76, 9, 4, 1]));
// → 0.068599434</code></pre></div></div></div></section><section><div class="slide-content"><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">function phi(table) {
 return (table[3] * table[0] - table[2] * table[1]) /
   Math.sqrt((table[2] + table[3]) *
             (table[0] + table[1]) *
             (table[1] + table[3]) *
             (table[0] + table[2]));
}</code></pre></div></div></div></section><section id="_vytvoření_tabulky"><h2>Vytvoření tabulky</h2><div class="slide-content"><div class="paragraph"><p>Z deníku potřebujeme vytvořit tabulku pro výpočet <strong>ϕ</strong>, testovací data jsou uložena v souboru link::jurnal.js[].</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">console.log(tableFor("pizza", JOURNAL));
// → [76, 9, 4, 1]</code></pre></div></div></div></section><section><div class="slide-content"><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">function tableFor(event, journal) {
 let table = [0, 0, 0, 0];
 for (let i = 0; i &lt; journal.length; i++) {
   let entry = journal[i], index = 0;
   if (entry.events.includes(event)) index += 1;
   if (entry.squirrel) index += 2;
   table[index] += 1;
 }
 return table;
}</code></pre></div></div></div></section><section id="_výpis_událostí"><h2>Výpis událostí</h2><div class="slide-content"><div class="paragraph"><p>Z deníku vypište všechny typy zaznamených události</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">console.log(journalEvents(JOURNAL));
// → ["carrot", "exercise", "weekend", "bread", …]</code></pre></div></div></div></section><section><div class="slide-content"><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">function journalEvents(journal) {
 let events = [];
 for (let entry of journal) {
   for (let event of entry.events) {
     if (!events.includes(event)) {
       events.push(event);
     }
   }
 }
 return events;
}</code></pre></div></div></div></section><section id="_spočítejte_ϕ_pro_všechny"><h2>Spočítejte <strong>ϕ</strong> pro všechny</h2><div class="slide-content"><div class="paragraph"><p>Z deníku vypište všechny typy zaznamených události</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">console.log(journalEvents(JOURNAL));
// → ["carrot", "exercise", "weekend", "bread", …]</code></pre></div></div></div></section><section><div class="slide-content"><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">function journalEvents(journal) {
 let events = [];
 for (let entry of journal) {
   for (let event of entry.events) {
     if (!events.includes(event)) {
       events.push(event);
     }
   }
 }
 return events;
}</code></pre></div></div></div></section><section id="_spočítejte_ϕ_pro_všechny_2"><h2>Spočítejte <strong>ϕ</strong> pro všechny</h2><div class="slide-content"><div class="paragraph"><p>Nyní můžeme jednoduše vypsat hodnoty korelace pro každou událost</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">for (let event of journalEvents(JOURNAL)) {
 console.log(event + ":", phi(tableFor(event, JOURNAL)));
}
// → carrot:   0.0140970969
// → exercise: 0.0685994341
// → weekend:  0.1371988681
// → bread:   -0.0757554019
// → pudding: -0.0648203724
// and so on...</code></pre></div></div></div></section><section id="_filtrování"><h2>Filtrování</h2><div class="slide-content"><div class="paragraph"><p>Příliš mnoho těch nepodstatných, vypište jen ty s hodinami <strong>ϕ</strong> většími než <em>0.1</em> nebo menší než <em>-0.1</em>.</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">// → weekend:        0.1371988681
// → brushed teeth: -0.3805211953
// → candy:          0.1296407447
// → work:          -0.1371988681
// → spaghetti:      0.2425356250
// → reading:        0.1106828054
// → peanuts:        0.5902679812</code></pre></div></div></div></section><section><div class="slide-content"><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">for (let event of journalEvents(JOURNAL)) {
 let correlation = phi(tableFor(event, JOURNAL));
 if (correlation &gt; 0.1 || correlation &lt; -0.1) {
   console.log(event + ":", correlation);
 }
}</code></pre></div></div></div></section><section id="_final_touch"><h2>Final touch</h2><div class="slide-content"><div class="paragraph"><p>Vytvořte v deníku nový event <code>peanut teeth</code>, který spojí dohromady událost kdy si Jacques dal oříšky a nevyčistil si zuby a zkuste provést analýzu pro tuto novou událost.</p></div></div></section></section>
<section><section id="_práce_se_seznamy"><h2>Práce se seznamy</h2><div class="slide-content"><div class="paragraph"><p>Již jsme si ukázaly dvě metody na seznamu <code>pop</code> a <code>push</code>, které odebírají/přidávají položku na konec seznamu.</p></div><div class="ulist"><ul><li><p>Existuje ale mnohem více užitečných metod.</p></li></ul></div></div></section><section id="_práce_se_začátkem_seznamu"><h2>Práce se začátkem seznamu</h2><div class="slide-content"><div class="paragraph"><p>Metody <code>shift</code> a <code>unshift</code> odstraňují/přidávají na začátek.</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let todoList = [];
function remember(task) {
 todoList.push(task);
}
function getTask() {
 return todoList.shift();
}
function rememberUrgently(task) {
 todoList.unshift(task);
}</code></pre></div></div></div></section><section id="_vyhledání_v_seznamu"><h2>Vyhledání v seznamu</h2><div class="slide-content"><div class="paragraph"><p>Metody <code>indexOf</code> a <code>lastIndexOf</code> vracejí index prvku.</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">console.log([1, 2, 3, 2, 1].indexOf(2));
// → 1
console.log([1, 2, 3, 2, 1].lastIndexOf(2));
// → 3</code></pre></div></div></div></section><section id="_podsenzamy"><h2>Podsenzamy</h2><div class="slide-content"><div class="paragraph"><p>Někdy je užitečné pracovat jen s částí senzma, k tomu slouží metoda <code>slice</code>.</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">console.log([0, 1, 2, 3, 4].slice(2, 4));
// → [2, 3]
console.log([0, 1, 2, 3, 4].slice(2));
// → [2, 3, 4]</code></pre></div></div></div></section><section id="_spojování_dvou_seznamů"><h2>Spojování dvou seznamů</h2><div class="slide-content"><div class="paragraph"><p>Pro spojení dvou seznamů nemůžeme použít <code>+</code> musíme použít metodu <code>concat</code>.</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">console.log([0, 1, 2] + [3, 4, 5]);
// → '0,1,23,4,5'
console.log([0, 1, 2].concat([3, 4, 5]));
// → [ 0, 1, 2, 3, 4, 5 ]</code></pre></div></div></div></section><section id="_příklad_2"><h2>Příklad</h2><div class="slide-content"><div class="quoteblock"><blockquote><div class="paragraph"><p>Za použití metod <code>slice</code> a <code>concat</code> vytvořte funkci <code>remove</code> která odstraní prvek ze seznamu</p></div></blockquote></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">console.log(remove(["a", "b", "c", "d", "e"], 2));
// → ["a", "b", "d", "e"]</code></pre></div></div></div></section><section><div class="slide-content"><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">function remove(array, index) {
 return array.slice(0, index)
             .concat(
               array.slice(index + 1)
             );
}</code></pre></div></div></div></section></section>
<section><section id="_řetězce_a_jejich_metody"><h2>Řetězce a jejich metody</h2><div class="slide-content"><div class="paragraph"><p>Řetězce stejne jako čísla a booleny nejsou objekty, proto jim můžeme přidávat vlastnosti a modifikovat je</p></div><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let kim = "Kim";
kim.age = 88;
console.log(kim.age);
// → undefined</code></pre></div></div></div></section><section id="_podřetězce_a_indexy"><h2>Podřetězce a indexy</h2><div class="slide-content"><div class="paragraph"><p>Stejně jako seznamy mají řetězce metodu <code>slice</code> a <code>indexOf</code></p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">console.log("coconuts".slice(4, 7));
// → nut
console.log("coconut".indexOf("u"));
// → 5
console.log("one two three".indexOf("ee"));
// → 11</code></pre></div></div></div></section><section id="_modifikace_okrajů"><h2>Modifikace okrajů</h2><div class="slide-content"><div class="paragraph"><p>U Řetězců se hodí umět odstranit bílé znaky z krajů, nebo naopak k řetězci něco přidat, případně řetězec namnožit</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">console.log("  okay \n ".trim());
// → okay
console.log(String(6).padStart(3, "0"));
// → 006
console.log("LA".repeat(3));
// → LALALA</code></pre></div></div></div></section><section id="_řetězce_a_seznamy"><h2>Řetězce a seznamy</h2><div class="slide-content"><div class="paragraph"><p>Mezi řetězci a sezname lze snado převádět pomocí metod <code>split</code> a <code>join</code></p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let sentence = "Secretarybirds specialize in stomping";
let words = sentence.split(" ");
console.log(words);
// → ["Secretarybirds", "specialize", "in", "stomping"]
console.log(words.join(". "));
// → Secretarybirds. specialize. in. stomping</code></pre></div></div></div></section></section>
<section><section id="_funkce_a_parametry"><h2>Funkce a parametry</h2><div class="slide-content"><div class="paragraph"><p>S parametry funkce si v JAvascriptu lze docela hrát</p></div></div></section><section id="_proměnný_počet_parametrů"><h2>Proměnný počet parametrů</h2><div class="slide-content"><div class="paragraph"><p>Javascript umožňuje aby funkce měli proměnný počet parametrů, to se zapisuje pomocí <code>&#8230;&#8203;</code> před názvem parametru.
* Zvažte například takovou funkci <code>max</code></p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">function max(...numbers) {
 let result = -Infinity;
 for (let number of numbers) {
   if (number &gt; result) result = number;
 }
 return result;
}
console.log(max(4, 1, 9, -2));
// → 9</code></pre></div></div></div></section><section id="_a_volání_funkce"><h2><code>&#8230;&#8203;</code> a volání funkce</h2><div class="slide-content"><div class="paragraph"><p><code>&#8230;&#8203;</code> se dají použít i pro volání funkce k "rozbalení" pole.</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let numbers = [5, 1, 7];
console.log(max(...numbers));
// → 7</code></pre></div></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let words = ["never", "fully"];
console.log(["will", ...words, "understand"]);
// → ["will", "never", "fully", "understand"]</code></pre></div></div></div></section><section id="_funkce_jako_parametr"><h2>Funkce jako parametr</h2><div class="slide-content"><div class="paragraph"><p>Protože funkce je vlastně proměnná, můžeme ji předat jiné funkci jako parametr, to má zajímavé konsekvence.</p></div>
<div class="ulist"><ul><li><p>Zvažte následující příklad, kdy máme a tu upravíme</p></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">for (let i = 0; i &lt; 10; i++) {
 console.log(i);
}</code></pre></div></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">function repeatLog(n) {
 for (let i = 0; i &lt; n; i++) {
   console.log(i);
 }
}</code></pre></div></div></div></section><section><div class="slide-content"><div class="paragraph"><p>Funkce <code>repeatLog</code> nám k ničemu jinému už nikdy asi nebude, co to udělat lépe &#8230;&#8203;</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">function repeat(n, action) {
 for (let i = 0; i &lt; n; i++) {
   action(i);
 }
}

repeat(3, console.log);
// → 0
// → 1
// → 2</code></pre></div></div></div></section><section><div class="slide-content"><div class="paragraph"><p>Nyní máme univerzální funkci <code>repeat</code>, kterou můžeme použít opakovaně k různým kouzlům</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let labels = [];
repeat(5, i =&gt; {
 labels.push(`Unit ${i + 1}`);
});
console.log(labels);
// → ["Unit 1", "Unit 2", "Unit 3", "Unit 4", "Unit 5"]</code></pre></div></div></div></section><section><div class="slide-content"><div class="paragraph"><p>Ok, to ještě nebyl ten pravý magic ;-)</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">function unless(test, then) {
 if (!test) then();
}

repeat(3, n =&gt; {
 unless(n % 2 == 1, () =&gt; {
   console.log(n, "is even");
 });
});
// → 0 is even
// → 2 is even</code></pre></div></div></div></section><section><div class="slide-content"><h3>Použítí u seznamů</h3><div class="paragraph"><p>Funkce, které přijímají jiné funkce jsou v JavaScriptu docela rozšířené</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">["A", "B"].forEach(l =&gt; console.log(l));
// → A
// → B</code></pre></div></div></div></section><section><div class="slide-content"><div class="paragraph"><p>Dalším příkladem je filtrace seznamu</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">[1,3,8,9,7,5,2,6,4].filter(n = &gt; n % 2)</code></pre></div></div></div></section><section><div class="slide-content"><div class="paragraph"><p>Nebo transformace položek v seznamu</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">[1,2,3,4].map(n = &gt; n*n )</code></pre></div></div></div></section><section id="_rozbalení_pole"><h2>Rozbalení pole</h2><div class="slide-content"><div class="paragraph"><p>V rámci parametrů funkce můžeme i "rozbalit" pole nebo objekt a vytáhnout z nich jen konkrétní vlastnosti.</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">function phi([n00, n01, n10, n11]) {
 return (n11 * n00 - n10 * n01) /
   Math.sqrt((n10 + n11) * (n00 + n01) *
             (n01 + n11) * (n00 + n10));
}</code></pre></div></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let {name} = {name: "Faraji", age: 23};
console.log(name);
// → Faraji</code></pre></div></div></div></section></section>
<section id="_json"><h2>JSON</h2><div class="slide-content"><div class="paragraph"><p>S Javascriptem je pevně spojen formát <em>json</em> který slouží pro serializace a deserializaci objektů.</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let string = JSON.stringify({squirrel: false,
                            events: ["weekend"]});
console.log(string);
// → {"squirrel":false,"events":["weekend"]}
console.log(JSON.parse(string).events);
// → ["weekend"]</code></pre></div></div></div></section>
<section><section id="_summary"><h2>Summary</h2><div class="slide-content"><div class="paragraph"><p>Objekty a pole (které jsou specifickým druhem objektu) poskytují způsoby, jak seskupit několik hodnot do jedné proměnné.
Koncepčně nám to umožňuje dát hromadu souvisejících věcí do tašky a pobíhat s taškou, místo abychom omotali ruce kolem všech jednotlivých věcí a snažili se je držet samostatně.</p></div></div></section><section><div class="slide-content"><div class="paragraph"><p>Většina proměnných v JavaScriptu má vlastnosti, výjimky jsou <code>null</code> a <code>undefined</code>.
* K vlastnostem se přistupuje pomocí <code>value.pro`p nebo `value["prop"]</code>.
* Objekty obvykle používají pro své vlastnosti názvy a ukládají víceméně jejich pevnou sadu.
* Pole na druhé straně obvykle obsahují různá množství koncepčně identických hodnot a jako názvy jejich vlastností používají čísla (od 0).</p></div></div></section></section>
<section><section id="_cvičení"><h2>Cvičení</h2></section><section id="_funkce_range_a_sum"><h2>Funkce <code>range</code> a <code>sum</code></h2><div class="slide-content"><div class="paragraph"><p>Implementace ukázky z první části.</p></div>
<div class="olist arabic"><ol class="arabic"><li><p>Vytvořte funkci <code>range</code>, která může mít až tři parametry: <code>start</code>, <code>end</code>, <code>step</code>, poslední je volitelný a která vygeneruje číselnou řadu do pole</p></li><li><p>Vytvořte funkci <code>sum</code> která dostane pole čísel a sečte je.</p></li></ol></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">console.log(range(1, 10));
// → [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]
console.log(range(5, 2, -1));
// → [5, 4, 3, 2]
console.log(sum(range(1, 10)));
// → 55</code></pre></div></div></div></section><section id="_reverzní_pole"><h2>Reverzní pole</h2><div class="slide-content"><div class="olist arabic"><ol class="arabic"><li><p>Vytvořte funkci <code>reverseArray</code> která jako parametr přijme pole a vrátí pole s otočenými prvky.</p></li><li><p>Vytvořte druhou funkci <code>reverseArrayInPlace</code>, která udělá to samé a modifikuje zadané pole.</p></li></ol></div>
<div class="listingblock"><div class="content"><pre>console.log(reverseArray(["A", "B", "C"]));
// → ["C", "B", "A"];
let arrayValue = [1, 2, 3, 4, 5];
reverseArrayInPlace(arrayValue);
console.log(arrayValue);
// → [5, 4, 3, 2, 1]</pre></div></div></div></section><section id="_porovnání_podle_hodnot"><h2>Porovnání podle hodnot</h2><div class="slide-content"><div class="paragraph"><p>Vytvořte funkci <code>deepEqual</code> která porovná zda dva objekty obsahují stejné hodnoty.
Pokud je vlastnost objektů opět objekt, pak i ty musí obsahovat stejné hodnoty.</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let obj = {here: {is: "an"}, object: 2};
console.log(deepEqual(obj, obj));
// → true
console.log(deepEqual(obj, {here: 1, object: 2}));
// → false
console.log(deepEqual(obj, {here: {is: "an"}, object: 2}));
// → true</code></pre></div></div></div></section></section></div></div><script src="https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/js/reveal.js"></script><script>Array.prototype.slice.call(document.querySelectorAll('.slides section')).forEach(function(slide) {
  if (slide.getAttribute('data-background-color')) return;
  // user needs to explicitly say he wants CSS color to override otherwise we might break custom css or theme (#226)
  if (!(slide.classList.contains('canvas') || slide.classList.contains('background'))) return;
  var bgColor = getComputedStyle(slide).backgroundColor;
  if (bgColor !== 'rgba(0, 0, 0, 0)' && bgColor !== 'transparent') {
    slide.setAttribute('data-background-color', bgColor);
    slide.style.backgroundColor = 'transparent';
  }
});

// More info about config & dependencies:
// - https://github.com/hakimel/reveal.js#configuration
// - https://github.com/hakimel/reveal.js#dependencies
Reveal.initialize({
  // Display presentation control arrows
  controls: true,
  // Help the user learn the controls by providing hints, for example by
  // bouncing the down arrow when they first encounter a vertical slide
  controlsTutorial: true,
  // Determines where controls appear, "edges" or "bottom-right"
  controlsLayout: 'bottom-right',
  // Visibility rule for backwards navigation arrows; "faded", "hidden"
  // or "visible"
  controlsBackArrows: 'faded',
  // Display a presentation progress bar
  progress: true,
  // Display the page number of the current slide
  slideNumber: false,
  // Control which views the slide number displays on
  showSlideNumber: 'all',
  // Add the current slide number to the URL hash so that reloading the
  // page/copying the URL will return you to the same slide
  hash: false,
  // Push each slide change to the browser history. Implies `hash: true`
  history: false,
  // Enable keyboard shortcuts for navigation
  keyboard: true,
  // Enable the slide overview mode
  overview: true,
  // Vertical centering of slides
  center: false,
  // Enables touch navigation on devices with touch input
  touch: true,
  // Loop the presentation
  loop: false,
  // Change the presentation direction to be RTL
  rtl: false,
  // See https://github.com/hakimel/reveal.js/#navigation-mode
  navigationMode: 'default',
  // Randomizes the order of slides each time the presentation loads
  shuffle: false,
  // Turns fragments on and off globally
  fragments: true,
  // Flags whether to include the current fragment in the URL,
  // so that reloading brings you to the same fragment position
  fragmentInURL: false,
  // Flags if the presentation is running in an embedded mode,
  // i.e. contained within a limited portion of the screen
  embedded: false,
  // Flags if we should show a help overlay when the questionmark
  // key is pressed
  help: true,
  // Flags if speaker notes should be visible to all viewers
  showNotes: false,
  // Global override for autolaying embedded media (video/audio/iframe)
  // - null: Media will only autoplay if data-autoplay is present
  // - true: All media will autoplay, regardless of individual setting
  // - false: No media will autoplay, regardless of individual setting
  autoPlayMedia: null,
  // Global override for preloading lazy-loaded iframes
  // - null: Iframes with data-src AND data-preload will be loaded when within
  //   the viewDistance, iframes with only data-src will be loaded when visible
  // - true: All iframes with data-src will be loaded when within the viewDistance
  // - false: All iframes with data-src will be loaded only when visible
  preloadIframes: null,
  // Number of milliseconds between automatically proceeding to the
  // next slide, disabled when set to 0, this value can be overwritten
  // by using a data-autoslide attribute on your slides
  autoSlide: 0,
  // Stop auto-sliding after user input
  autoSlideStoppable: true,
  // Use this method for navigation when auto-sliding
  autoSlideMethod: Reveal.navigateNext,
  // Specify the average time in seconds that you think you will spend
  // presenting each slide. This is used to show a pacing timer in the
  // speaker view
  defaultTiming: 120,
  // Specify the total time in seconds that is available to
  // present.  If this is set to a nonzero value, the pacing
  // timer will work out the time available for each slide,
  // instead of using the defaultTiming value
  totalTime: 0,
  // Specify the minimum amount of time you want to allot to
  // each slide, if using the totalTime calculation method.  If
  // the automated time allocation causes slide pacing to fall
  // below this threshold, then you will see an alert in the
  // speaker notes window
  minimumTimePerSlide: 0,
  // Enable slide navigation via mouse wheel
  mouseWheel: false,
  // Hide cursor if inactive
  hideInactiveCursor: true,
  // Time before the cursor is hidden (in ms)
  hideCursorTime: 5000,
  // Hides the address bar on mobile devices
  hideAddressBar: true,
  // Opens links in an iframe preview overlay
  // Add `data-preview-link` and `data-preview-link="false"` to customise each link
  // individually
  previewLinks: false,
  // Transition style (e.g., none, fade, slide, convex, concave, zoom)
  transition: 'slide',
  // Transition speed (e.g., default, fast, slow)
  transitionSpeed: 'default',
  // Transition style for full page slide backgrounds (e.g., none, fade, slide, convex, concave, zoom)
  backgroundTransition: 'fade',
  // Number of slides away from the current that are visible
  viewDistance: 3,
  // Number of slides away from the current that are visible on mobile
  // devices. It is advisable to set this to a lower number than
  // viewDistance in order to save resources.
  mobileViewDistance: 3,
  // Parallax background image (e.g., "'https://s3.amazonaws.com/hakim-static/reveal-js/reveal-parallax-1.jpg'")
  parallaxBackgroundImage: '',
  // Parallax background size in CSS syntax (e.g., "2100px 900px")
  parallaxBackgroundSize: '',
  // Number of pixels to move the parallax background per slide
  // - Calculated automatically unless specified
  // - Set to 0 to disable movement along an axis
  parallaxBackgroundHorizontal: null,
  parallaxBackgroundVertical: null,
  // The display mode that will be used to show slides
  display: 'block',

  // The "normal" size of the presentation, aspect ratio will be preserved
  // when the presentation is scaled to fit different resolutions. Can be
  // specified using percentage units.
  width: 1250,
  height: 700,

  // Factor of the display size that should remain empty around the content
  margin: 0.1,

  // Bounds for smallest/largest possible scale to apply to content
  minScale: 0.2,
  maxScale: 1.5,

  // PDF Export Options
  // Put each fragment on a separate page
  pdfSeparateFragments: true,
  // For slides that do not fit on a page, max number of pages
  pdfMaxPagesPerSlide: 1,

  // Optional libraries used to extend on reveal.js
  dependencies: [
      { src: 'https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/plugin/zoom-js/zoom.js', async: true },
      { src: 'https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/plugin/notes/notes.js', async: true }
  ],

  

});</script><script>var dom = {};
dom.slides = document.querySelector('.reveal .slides');

function getRemainingHeight(element, slideElement, height) {
  height = height || 0;
  if (element) {
    var newHeight, oldHeight = element.style.height;
    // Change the .stretch element height to 0 in order find the height of all
    // the other elements
    element.style.height = '0px';
    // In Overview mode, the parent (.slide) height is set of 700px.
    // Restore it temporarily to its natural height.
    slideElement.style.height = 'auto';
    newHeight = height - slideElement.offsetHeight;
    // Restore the old height, just in case
    element.style.height = oldHeight + 'px';
    // Clear the parent (.slide) height. .removeProperty works in IE9+
    slideElement.style.removeProperty('height');
    return newHeight;
  }
  return height;
}

function layoutSlideContents(width, height) {
  // Handle sizing of elements with the 'stretch' class
  toArray(dom.slides.querySelectorAll('section .stretch')).forEach(function (element) {
    // Determine how much vertical space we can use
    var limit = 5; // hard limit
    var parent = element.parentNode;
    while (parent.nodeName !== 'SECTION' && limit > 0) {
      parent = parent.parentNode;
      limit--;
    }
    if (limit === 0) {
      // unable to find parent, aborting!
      return;
    }
    var remainingHeight = getRemainingHeight(element, parent, height);
    // Consider the aspect ratio of media elements
    if (/(img|video)/gi.test(element.nodeName)) {
      var nw = element.naturalWidth || element.videoWidth, nh = element.naturalHeight || element.videoHeight;
      var es = Math.min(width / nw, remainingHeight / nh);
      element.style.width = (nw * es) + 'px';
      element.style.height = (nh * es) + 'px';
    } else {
      element.style.width = width + 'px';
      element.style.height = remainingHeight + 'px';
    }
  });
}

function toArray(o) {
  return Array.prototype.slice.call(o);
}

Reveal.addEventListener('slidechanged', function () {
  layoutSlideContents(1250, 700)
});
Reveal.addEventListener('ready', function () {
  layoutSlideContents(1250, 700)
});
Reveal.addEventListener('resize', function () {
  layoutSlideContents(1250, 700)
});</script><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/lib/css/monokai.css"/>
<script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.18.1/highlight.min.js"></script>

<script>

/* highlightjs-line-numbers.js 2.6.0 | (C) 2018 Yauheni Pakala | MIT License | github.com/wcoder/highlightjs-line-numbers.js */
/* Edited by Hakim for reveal.js; removed async timeout */
!function(n,e){"use strict";function t(){var n=e.createElement("style");n.type="text/css",n.innerHTML=g(".{0}{border-collapse:collapse}.{0} td{padding:0}.{1}:before{content:attr({2})}",[v,L,b]),e.getElementsByTagName("head")[0].appendChild(n)}function r(t){"interactive"===e.readyState||"complete"===e.readyState?i(t):n.addEventListener("DOMContentLoaded",function(){i(t)})}function i(t){try{var r=e.querySelectorAll("code.hljs,code.nohighlight");for(var i in r)r.hasOwnProperty(i)&&l(r[i],t)}catch(o){n.console.error("LineNumbers error: ",o)}}function l(n,e){"object"==typeof n&&f(function(){n.innerHTML=s(n,e)})}function o(n,e){if("string"==typeof n){var t=document.createElement("code");return t.innerHTML=n,s(t,e)}}function s(n,e){e=e||{singleLine:!1};var t=e.singleLine?0:1;return c(n),a(n.innerHTML,t)}function a(n,e){var t=u(n);if(""===t[t.length-1].trim()&&t.pop(),t.length>e){for(var r="",i=0,l=t.length;i<l;i++)r+=g('<tr><td class="{0}"><div class="{1} {2}" {3}="{5}"></div></td><td class="{4}"><div class="{1}">{6}</div></td></tr>',[j,m,L,b,p,i+1,t[i].length>0?t[i]:" "]);return g('<table class="{0}">{1}</table>',[v,r])}return n}function c(n){var e=n.childNodes;for(var t in e)if(e.hasOwnProperty(t)){var r=e[t];h(r.textContent)>0&&(r.childNodes.length>0?c(r):d(r.parentNode))}}function d(n){var e=n.className;if(/hljs-/.test(e)){for(var t=u(n.innerHTML),r=0,i="";r<t.length;r++){var l=t[r].length>0?t[r]:" ";i+=g('<span class="{0}">{1}</span>\n',[e,l])}n.innerHTML=i.trim()}}function u(n){return 0===n.length?[]:n.split(y)}function h(n){return(n.trim().match(y)||[]).length}function f(e){e()}function g(n,e){return n.replace(/{(\d+)}/g,function(n,t){return e[t]?e[t]:n})}var v="hljs-ln",m="hljs-ln-line",p="hljs-ln-code",j="hljs-ln-numbers",L="hljs-ln-n",b="data-line-number",y=/\r\n|\r|\n/g;n.hljs?(n.hljs.initLineNumbersOnLoad=r,n.hljs.lineNumbersBlock=l,n.hljs.lineNumbersValue=o,t()):n.console.error("highlight.js not detected!")}(window,document);

/**
 * This reveal.js plugin is wrapper around the highlight.js
 * syntax highlighting library.
 */
(function( root, factory ) {
  if (typeof define === 'function' && define.amd) {
    root.RevealHighlight = factory();
  } else if( typeof exports === 'object' ) {
    module.exports = factory();
  } else {
    // Browser globals (root is window)
    root.RevealHighlight = factory();
  }
}( this, function() {

  // Function to perform a better "data-trim" on code snippets
  // Will slice an indentation amount on each line of the snippet (amount based on the line having the lowest indentation length)
  function betterTrim(snippetEl) {
    // Helper functions
    function trimLeft(val) {
      // Adapted from https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String/Trim#Polyfill
      return val.replace(/^[\s\uFEFF\xA0]+/g, '');
    }
    function trimLineBreaks(input) {
      var lines = input.split('\n');

      // Trim line-breaks from the beginning
      for (var i = 0; i < lines.length; i++) {
        if (lines[i].trim() === '') {
          lines.splice(i--, 1);
        } else break;
      }

      // Trim line-breaks from the end
      for (var i = lines.length-1; i >= 0; i--) {
        if (lines[i].trim() === '') {
          lines.splice(i, 1);
        } else break;
      }

      return lines.join('\n');
    }

    // Main function for betterTrim()
    return (function(snippetEl) {
      var content = trimLineBreaks(snippetEl.innerHTML);
      var lines = content.split('\n');
      // Calculate the minimum amount to remove on each line start of the snippet (can be 0)
      var pad = lines.reduce(function(acc, line) {
        if (line.length > 0 && trimLeft(line).length > 0 && acc > line.length - trimLeft(line).length) {
          return line.length - trimLeft(line).length;
        }
        return acc;
      }, Number.POSITIVE_INFINITY);
      // Slice each line with this amount
      return lines.map(function(line, index) {
        return line.slice(pad);
      })
        .join('\n');
    })(snippetEl);
  }

  var RevealHighlight = {

    HIGHLIGHT_STEP_DELIMITER: '|',
    HIGHLIGHT_LINE_DELIMITER: ',',
    HIGHLIGHT_LINE_RANGE_DELIMITER: '-',

    init: function() {

      // Read the plugin config options and provide fallbacks
      var config = Reveal.getConfig().highlight || {};
      config.highlightOnLoad = typeof config.highlightOnLoad === 'boolean' ? config.highlightOnLoad : true;
      config.escapeHTML = typeof config.escapeHTML === 'boolean' ? config.escapeHTML : true;

      [].slice.call( document.querySelectorAll( '.reveal pre code' ) ).forEach( function( block ) {

        // Trim whitespace if the "data-trim" attribute is present
        if( block.hasAttribute( 'data-trim' ) && typeof block.innerHTML.trim === 'function' ) {
          block.innerHTML = betterTrim( block );
        }

        // Escape HTML tags unless the "data-noescape" attrbute is present
        if( config.escapeHTML && !block.hasAttribute( 'data-noescape' )) {
          block.innerHTML = block.innerHTML.replace( /</g,"&lt;").replace(/>/g, '&gt;' );
        }

        // Re-highlight when focus is lost (for contenteditable code)
        block.addEventListener( 'focusout', function( event ) {
          hljs.highlightBlock( event.currentTarget );
        }, false );

        if( config.highlightOnLoad ) {
          RevealHighlight.highlightBlock( block );
        }
      } );

    },

    /**
     * Highlights a code block. If the <code> node has the
     * 'data-line-numbers' attribute we also generate slide
     * numbers.
     *
     * If the block contains multiple line highlight steps,
     * we clone the block and create a fragment for each step.
     */
    highlightBlock: function( block ) {

      hljs.highlightBlock( block );

      // Don't generate line numbers for empty code blocks
      if( block.innerHTML.trim().length === 0 ) return;

      if( block.hasAttribute( 'data-line-numbers' ) ) {
        hljs.lineNumbersBlock( block, { singleLine: true } );

        // If there is at least one highlight step, generate
        // fragments
        var highlightSteps = RevealHighlight.deserializeHighlightSteps( block.getAttribute( 'data-line-numbers' ) );
        if( highlightSteps.length > 1 ) {

          // If the original code block has a fragment-index,
          // each clone should follow in an incremental sequence
          var fragmentIndex = parseInt( block.getAttribute( 'data-fragment-index' ), 10 );
          if( typeof fragmentIndex !== 'number' || isNaN( fragmentIndex ) ) {
            fragmentIndex = null;
          }

          // Generate fragments for all steps except the original block
          highlightSteps.slice(1).forEach( function( highlight ) {

            var fragmentBlock = block.cloneNode( true );
            fragmentBlock.setAttribute( 'data-line-numbers', RevealHighlight.serializeHighlightSteps( [ highlight ] ) );
            fragmentBlock.classList.add( 'fragment' );
            block.parentNode.appendChild( fragmentBlock );
            RevealHighlight.highlightLines( fragmentBlock );

            if( typeof fragmentIndex === 'number' ) {
              fragmentBlock.setAttribute( 'data-fragment-index', fragmentIndex );
              fragmentIndex += 1;
            }
            else {
              fragmentBlock.removeAttribute( 'data-fragment-index' );
            }

          } );

          block.removeAttribute( 'data-fragment-index' )
          block.setAttribute( 'data-line-numbers', RevealHighlight.serializeHighlightSteps( [ highlightSteps[0] ] ) );

        }

        RevealHighlight.highlightLines( block );

      }

    },

    /**
     * Visually emphasize specific lines within a code block.
     * This only works on blocks with line numbering turned on.
     *
     * @param {HTMLElement} block a <code> block
     * @param {String} [linesToHighlight] The lines that should be
     * highlighted in this format:
     * "1" 		= highlights line 1
     * "2,5"	= highlights lines 2 & 5
     * "2,5-7"	= highlights lines 2, 5, 6 & 7
     */
    highlightLines: function( block, linesToHighlight ) {

      var highlightSteps = RevealHighlight.deserializeHighlightSteps( linesToHighlight || block.getAttribute( 'data-line-numbers' ) );

      if( highlightSteps.length ) {

        highlightSteps[0].forEach( function( highlight ) {

          var elementsToHighlight = [];

          // Highlight a range
          if( typeof highlight.end === 'number' ) {
            elementsToHighlight = [].slice.call( block.querySelectorAll( 'table tr:nth-child(n+'+highlight.start+'):nth-child(-n+'+highlight.end+')' ) );
          }
          // Highlight a single line
          else if( typeof highlight.start === 'number' ) {
            elementsToHighlight = [].slice.call( block.querySelectorAll( 'table tr:nth-child('+highlight.start+')' ) );
          }

          if( elementsToHighlight.length ) {
            elementsToHighlight.forEach( function( lineElement ) {
              lineElement.classList.add( 'highlight-line' );
            } );

            block.classList.add( 'has-highlights' );
          }

        } );

      }

    },

    /**
     * Parses and formats a user-defined string of line
     * numbers to highlight.
     *
     * @example
     * RevealHighlight.deserializeHighlightSteps( '1,2|3,5-10' )
     * // [
     * //   [ { start: 1 }, { start: 2 } ],
     * //   [ { start: 3 }, { start: 5, end: 10 } ]
     * // ]
     */
    deserializeHighlightSteps: function( highlightSteps ) {

      // Remove whitespace
      highlightSteps = highlightSteps.replace( /\s/g, '' );

      // Divide up our line number groups
      highlightSteps = highlightSteps.split( RevealHighlight.HIGHLIGHT_STEP_DELIMITER );

      return highlightSteps.map( function( highlights ) {

        return highlights.split( RevealHighlight.HIGHLIGHT_LINE_DELIMITER ).map( function( highlight ) {

          // Parse valid line numbers
          if( /^[\d-]+$/.test( highlight ) ) {

            highlight = highlight.split( RevealHighlight.HIGHLIGHT_LINE_RANGE_DELIMITER );

            var lineStart = parseInt( highlight[0], 10 ),
              lineEnd = parseInt( highlight[1], 10 );

            if( isNaN( lineEnd ) ) {
              return {
                start: lineStart
              };
            }
            else {
              return {
                start: lineStart,
                end: lineEnd
              };
            }

          }
          // If no line numbers are provided, no code will be highlighted
          else {

            return {};

          }

        } );

      } );

    },

    /**
     * Serializes parsed line number data into a string so
     * that we can store it in the DOM.
     */
    serializeHighlightSteps: function( highlightSteps ) {

      return highlightSteps.map( function( highlights ) {

        return highlights.map( function( highlight ) {

          // Line range
          if( typeof highlight.end === 'number' ) {
            return highlight.start + RevealHighlight.HIGHLIGHT_LINE_RANGE_DELIMITER + highlight.end;
          }
          // Single line
          else if( typeof highlight.start === 'number' ) {
            return highlight.start;
          }
          // All lines
          else {
            return '';
          }

        } ).join( RevealHighlight.HIGHLIGHT_LINE_DELIMITER );

      } ).join( RevealHighlight.HIGHLIGHT_STEP_DELIMITER );

    }

  }

  Reveal.registerPlugin( 'highlight', RevealHighlight );

  return RevealHighlight;

}));
        
hljs.initHighlightingOnLoad();
</script></body></html>